package com.springboot.CustomSecurityWithDB.app.config;


import java.io.IOException;



import org.springframework.security.core.AuthenticationException;
import org.springframework.security.web.authentication.www.BasicAuthenticationEntryPoint;
import org.springframework.stereotype.Component;

import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;

@Component
public class TopicAuthenticationEntryPoint extends
BasicAuthenticationEntryPoint {

	@Override
	public void commence(HttpServletRequest request,
			HttpServletResponse response,
		     AuthenticationException authException)
		    		 throws IOException {


		response.addHeader("WWW-Authenticate",
				"Basic realm=\"" + getRealmName() + "\"");
		response.sendError(HttpServletResponse.SC_UNAUTHORIZED,
				authException.getMessage());
	}

	@Override
	public void afterPropertiesSet() {
		setRealmName("Topic security application Realm");
	}
}
