package com.springboot.CustomSecurityWithDB.service.impl;


import java.util.Arrays;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.core.GrantedAuthority;
import org.springframework.security.core.authority.SimpleGrantedAuthority;
import org.springframework.security.core.userdetails.User;
import org.springframework.security.core.userdetails.UserDetails;
import org.springframework.security.core.userdetails.UserDetailsService;
import org.springframework.security.core.userdetails.UsernameNotFoundException;
import org.springframework.stereotype.Service;

import com.springboot.CustomSecurityWithDB.dao.UserInfoDAO;
import com.springboot.CustomSecurityWithDB.entities.UserInfo;


@Service
public class UserDetailsServiceImpl
implements UserDetailsService {

	@Autowired
	private UserInfoDAO userInfoDAO;

	@Override
	public UserDetails loadUserByUsername(String userName) throws UsernameNotFoundException {
		UserInfo userInfo = userInfoDAO.getActiveUser(userName);

		//userInfo.getRole() ==> Already Having ROLE_ in the database itself. Hence directly giving this setter
		GrantedAuthority authority = new SimpleGrantedAuthority(userInfo.getRole());

		User user = new User(userInfo.getUserName(),
				userInfo.getPassword(),Arrays.asList(authority));

		UserDetails userDetails = (UserDetails)user;
		return userDetails;
	}
}
